<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="A trait that can provide the `Span` of the complete contents of a syntax tree node."><meta name="keywords" content="rust, rustlang, rust-lang, spanned"><title>syn::spanned - Rust</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc mod"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../syn/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"><a href="#">Module spanned</a></h2><div class="sidebar-elems"><section><div class="block"><ul><li><a href="#traits">Traits</a></li></ul></div></section></div></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../syn/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="main-heading">
    <h1 class="fqn"><span class="in-band">Module <a href="../index.html">syn</a>::<wbr><a class="mod" href="#">spanned</a><button id="copy-path" onclick="copy_path(this)" title="Copy item path to clipboard"><img src="../../clipboard.svg" width="19" height="18" alt="Copy item path"></button></span></h1><span class="out-of-band"><a class="srclink" href="../../src/syn/spanned.rs.html#1-114">source</a> · <a id="toggle-all-docs" href="javascript:void(0)" title="collapse all docs">[<span class="inner">&#x2212;</span>]</a></span></div><details class="rustdoc-toggle top-doc" open><summary class="hideme"><span>Expand description</span></summary><div class="docblock"><p>A trait that can provide the <code>Span</code> of the complete contents of a syntax
tree node.</p>
<p><em>This module is available only if Syn is built with both the <code>&quot;parsing&quot;</code> and
<code>&quot;printing&quot;</code> features.</em></p>
<br>
<h2 id="example"><a href="#example">Example</a></h2>
<p>Suppose in a procedural macro we have a <a href="../enum.Type.html"><code>Type</code></a> that we want to assert
implements the <a href="https://doc.rust-lang.org/nightly/core/marker/trait.Sync.html"><code>Sync</code></a> trait. Maybe this is the type of one of the fields
of a struct for which we are deriving a trait implementation, and we need to
be able to pass a reference to one of those fields across threads.</p>
<p>If the field type does <em>not</em> implement <code>Sync</code> as required, we want the
compiler to report an error pointing out exactly which type it was.</p>
<p>The following macro code takes a variable <code>ty</code> of type <code>Type</code> and produces a
static assertion that <code>Sync</code> is implemented for that type.</p>

<div class="example-wrap"><pre class="rust rust-example-rendered"><code><span class="kw">use</span> <span class="ident">proc_macro::TokenStream</span>;
<span class="kw">use</span> <span class="ident">proc_macro2::Span</span>;
<span class="kw">use</span> <span class="ident">quote::quote_spanned</span>;
<span class="kw">use</span> <span class="ident">syn::Type</span>;
<span class="kw">use</span> <span class="ident">syn::spanned::Spanned</span>;

<span class="attribute">#[<span class="ident">proc_macro_derive</span>(<span class="ident">MyMacro</span>)]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">my_macro</span>(<span class="ident">input</span>: <span class="ident">TokenStream</span>) -&gt; <span class="ident">TokenStream</span> {
    <span class="comment">/* ... */</span>

    <span class="kw">let</span> <span class="ident">assert_sync</span> <span class="op">=</span> <span class="macro">quote_spanned!</span> {<span class="ident">ty</span>.<span class="ident">span</span>()=&gt;
        <span class="kw">struct</span> <span class="ident">_AssertSync</span> <span class="kw">where</span> #<span class="ident">ty</span>: <span class="ident">Sync</span>;
    };

    <span class="comment">/* ... */</span>
}</code></pre></div>
<p>By inserting this <code>assert_sync</code> fragment into the output code generated by
our macro, the user’s code will fail to compile if <code>ty</code> does not implement
<code>Sync</code>. The errors they would see look like the following.</p>
<div class="example-wrap"><pre class="language-text"><code>error[E0277]: the trait bound `*const i32: std::marker::Sync` is not satisfied
  --&gt; src/main.rs:10:21
   |
10 |     bad_field: *const i32,
   |                ^^^^^^^^^^ `*const i32` cannot be shared between threads safely</code></pre></div>
<p>In this technique, using the <code>Type</code>’s span for the error message makes the
error appear in the correct place underlining the right type.</p>
<br>
<h2 id="limitations"><a href="#limitations">Limitations</a></h2>
<p>The underlying <a href="https://doc.rust-lang.org/nightly/proc_macro/struct.Span.html#method.join" title="proc_macro::Span::join"><code>proc_macro::Span::join</code></a> method is nightly-only. When
called from within a procedural macro in a nightly compiler, <code>Spanned</code> will
use <code>join</code> to produce the intended span. When not using a nightly compiler,
only the span of the <em>first token</em> of the syntax tree node is returned.</p>
<p>In the common case of wanting to use the joined span as the span of a
<code>syn::Error</code>, consider instead using <a href="../parse/struct.Error.html#method.new_spanned"><code>syn::Error::new_spanned</code></a> which is
able to span the error correctly under the complete syntax tree node without
needing the unstable <code>join</code>.</p>
</div></details><h2 id="traits" class="small-section-header"><a href="#traits">Traits</a></h2>
<div class="item-table"><div class="item-row"><div class="item-left module-item"><a class="trait" href="trait.Spanned.html" title="syn::spanned::Spanned trait">Spanned</a></div><div class="item-right docblock-short"><p>A trait that can provide the <code>Span</code> of the complete contents of a syntax
tree node.</p>
</div></div></div></section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="syn" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>